open Classes;;

(*  initial map  *)
let map_bar = [|[|1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1|]; 
                [|1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1|];
                [|1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1|];
                [|1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1|];
                [|1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1|];
                [|1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1|];
                [|1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1|];
                [|1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1|];
                [|1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1|];
                [|1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1|];
                [|1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1|];
                [|1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1|];
                [|1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1|];
                [|1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1|];
                [|1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1|]|]
;;

let gmap = new gamemap;;

let map_width = float(15);;
let map_height = float(15);;
let pi = 3.14159265;;
let r = 0.49;;
let v = 0.05;;
let width = 1.;;
let colorb = (0.2, 0.2, 0.8);; 

let total_score = ref 0;;

let pacman = new player;;
let ghost_g = new item;;
let gift_g = new item;;

let px = ref 7.5;;
let py = ref 7.5;;
let vx = ref 0.0;;
let vy = ref 0.0;;
let next_dir = ref 0;;
let now_dir = ref 0;;
let colorp = (1., 1., 0.);;
let counter = ref 0;;


let circle x px py r = [(sin x) *. r +. px, (cos x) *. r +. py];;

(*  check if the pacman and ghosts hit the bar *)
let check_hit_bar_x x y =
        if map_bar.(truncate (y /. width)).(truncate (x /. width)) = 1 || 
            map_bar.(truncate ((y +. r) /. width)).(truncate (x /. width)) = 1 ||
            map_bar.(truncate ((y -. r) /. width)).(truncate (x /. width)) = 1 then
            true
        else false
;;
let check_hit_bar_y x y =
        if map_bar.(truncate (y /. width)).(truncate (x /. width)) = 1 ||
           map_bar.(truncate (y /. width)).(truncate ((x +. r) /. width)) = 1 ||
           map_bar.(truncate (y /. width)).(truncate ((x -. r) /. width)) = 1 then
            true
        else false
;;

(*  check if the item need to change the direction *)
let check_item_change_dir item = 
    (*if (vx = 0.) && ((abs_float (y-.float(truncate(y)))) < 0.05) &&*)
    if (item#getNowDir = 0 || item#getNowDir = 2) && (item#getMoveCounter <= 0) && ((((item#getPoint)#getX-50) mod 100) < item#getSpeed) &&
       (map_bar.((item#getPoint)#getY / 100 + 1).((item#getPoint)#getX / 100) != 1 ||
        map_bar.((item#getPoint)#getY / 100 - 1).((item#getPoint)#getX / 100) != 1) then
            true
    else if (item#getNowDir = 1 || item#getNowDir = 3) && (item#getMoveCounter <= 0) && ((((item#getPoint)#getY-50) mod 100) < item#getSpeed) &&
       (map_bar.((item#getPoint)#getY / 100).((item#getPoint)#getX / 100 + 1) != 1 ||
        map_bar.((item#getPoint)#getY / 100).((item#getPoint)#getX / 100 - 1) != 1) then
            true
    else if ((item#getVelocity)#getX = 0) && ((item#getVelocity)#getY = 0) then
            true
    else false;
;;

(*  set the velocity of an item *)
let set_item_v vxx vyy item = 
    (item#getVelocity)#setX vxx;
    (item#getVelocity)#setY vyy;
    item#setNowDir item#getNextDir;
;;

(*  read from keyboard *)
let keyboard ~key ~x ~y =
    match key with
        | 27 -> exit 0
        | 113 -> exit 0
        | _ -> ignore (Printf.printf "Key: %c %d pressed.\n%!" (char_of_int key) key)
;;

let special_key ~key ~x ~y =
    match key with
        | Glut.KEY_LEFT -> pacman#setNextDir 0
        | Glut.KEY_UP -> pacman#setNextDir 1
        | Glut.KEY_RIGHT -> pacman#setNextDir 2
        | Glut.KEY_DOWN -> pacman#setNextDir 3
        | _ -> print_endline("Special key pressed")
;;


(*  set the new location of an item *)
let move_item item =
    if (item#getNextDir = 0) &&
        not (check_hit_bar_x (((float((item#getPoint)#getX) -. (float(item#getSpeed))) /. 100.) -. item#getRadius) 
                              (float((item#getPoint)#getY) /. 100.)) 
        then set_item_v (- item#getSpeed) 0 item
    else if (item#getNextDir = 1) &&
        not (check_hit_bar_y  (float((item#getPoint)#getX) /. 100.)
                             (((float((item#getPoint)#getY) +. (float(item#getSpeed))) /. 100.) +. item#getRadius)) 
        then set_item_v 0 item#getSpeed item
    else if (item#getNextDir = 2) &&
        not (check_hit_bar_x (((float((item#getPoint)#getX) +. (float(item#getSpeed))) /. 100.) +. item#getRadius) 
                              (float((item#getPoint)#getY) /. 100.)) 
        then set_item_v item#getSpeed 0 item
    else if (item#getNextDir = 3) &&
        not (check_hit_bar_y  (float((item#getPoint)#getX) /. 100.)
                             (((float((item#getPoint)#getY) -. (float(item#getSpeed))) /. 100.) -. item#getRadius)) 
        then set_item_v 0 (- item#getSpeed) item
    else if (item#getNextDir = -1)
        then set_item_v 0 0 item;

    if (item#getVelocity)#getX > 0 && 
       (check_hit_bar_x ((float((item#getPoint)#getX) +. float((item#getVelocity)#getX)) /. 100. +. item#getRadius) 
                        ((float((item#getPoint)#getY) +. float((item#getVelocity)#getY)) /. 100.) ) 
        then (item#getVelocity)#setX 0
    else if (item#getVelocity)#getX < 0 && 
       (check_hit_bar_x ((float((item#getPoint)#getX) +. float((item#getVelocity)#getX)) /. 100. -. item#getRadius) 
                        ((float((item#getPoint)#getY) +. float((item#getVelocity)#getY)) /. 100.) ) 
        then (item#getVelocity)#setX 0
    else if (item#getVelocity)#getY > 0 && 
       (check_hit_bar_y ((float((item#getPoint)#getX) +. float((item#getVelocity)#getX)) /. 100.) 
                        ((float((item#getPoint)#getY) +. float((item#getVelocity)#getY)) /. 100. +. item#getRadius) ) 
        then (item#getVelocity)#setY 0
    else if (item#getVelocity)#getY < 0 && 
       (check_hit_bar_y ((float((item#getPoint)#getX) +. float((item#getVelocity)#getX)) /. 100.) 
                        ((float((item#getPoint)#getY) +. float((item#getVelocity)#getY)) /. 100. -. item#getRadius) ) 
        then (item#getVelocity)#setY 0;
    if ((item#getVelocity)#getX = 0) && ((item#getVelocity)#getY = 0) then item#setNowDir (-1);
    (item#getPoint)#setX ((item#getPoint)#getX + (item#getVelocity)#getX);
    (item#getPoint)#setY ((item#getPoint)#getY + (item#getVelocity)#getY);
;;

    
(*  draw an item on the screen*)
let draw_item item = 
    GlDraw.color (item#getColor);
    GlDraw.begins `polygon;
    for i=0 to 359 do
        List.iter GlDraw.vertex2 (circle (2. *. pi *. float i /. 360.) (float((item#getPoint)#getX) /. 100.) (float((item#getPoint)#getY) /. 100.) (item#getRadius))
    done;
    GlDraw.ends ();
;;



let r0 = ref 0;;
let r1 = ref 0;;
let r2 = ref 0;;
let r3 = ref 0;;
let r_array = [|r0; r1; r2; r3|];;
let d0 = ref 0;;
let d1 = ref 0;;
let d2 = ref 0;;
let d3 = ref 0;;
let dis_now = ref 0;;
let d_array = [|d0; d1; d2; d3|];;
let get_weight_random_dir ran = 

    if ran < !r0 then 0
    else if ran < (!r0) + (!r1) then 1
    else if ran < (!r0) + (!r1) + (!r2) then 2
    else 3
;;

let set_bar_dir item = 
    
    if  (check_hit_bar_x (((float((item#getPoint)#getX) -. (float(item#getSpeed))) /. 100.) -. item#getRadius) 
                              (float((item#getPoint)#getY) /. 100.)) 
        then r0 := 1;
    if  (check_hit_bar_y  (float((item#getPoint)#getX) /. 100.)
                             (((float((item#getPoint)#getY) +. (float(item#getSpeed))) /. 100.) +. item#getRadius)) 
        then r1 := 1;
    if  (check_hit_bar_x (((float((item#getPoint)#getX) +. (float(item#getSpeed))) /. 100.) +. item#getRadius) 
                              (float((item#getPoint)#getY) /. 100.)) 
        then r2 := 1;
    if  (check_hit_bar_y  (float((item#getPoint)#getX) /. 100.)
                             (((float((item#getPoint)#getY) -. (float(item#getSpeed))) /. 100.) -. item#getRadius)) 
        then r3 := 1;
;;

(*  calculate the distance between pacman and ghost *)
let calculate_dist item = 
    d0 := abs((item#getPoint#getX - 100) - pacman#getPoint#getX) +
          abs((item#getPoint#getY) - pacman#getPoint#getY);
    d1 := abs((item#getPoint#getX) - pacman#getPoint#getX) +
          abs((item#getPoint#getY + 100) - pacman#getPoint#getY);
    d2 := abs((item#getPoint#getX + 100) - pacman#getPoint#getX) +
          abs((item#getPoint#getY) - pacman#getPoint#getY);
    d3 := abs((item#getPoint#getX) - pacman#getPoint#getX) +
          abs((item#getPoint#getY - 100) - pacman#getPoint#getY);
    dis_now := abs((item#getPoint#getX) - pacman#getPoint#getX) +
               abs((item#getPoint#getY) - pacman#getPoint#getY);
;;


(*  difficulty level *)
let lv2_ai item =  
    r0 := 25;
    r1 := 25;
    r2 := 25;
    r3 := 25;
    if item#getNowDir >=0 && item#getNowDir <=3 then
        r_array.(item#getNowDir) := 5;
    calculate_dist item;
    for i=0 to 3 do
        if (!(d_array.(i)) < !dis_now) then
            r_array.(i) := 2000;
    done;
    set_bar_dir item;
    get_weight_random_dir (Random.int (!r0 + !r1 + !r2 + !r3))
;;
let lv1_ai item =  
    r0 := 25;
    r1 := 25;
    r2 := 25;
    r3 := 25;
    if item#getNowDir >=0 && item#getNowDir <=3 then
        r_array.(item#getNowDir) := 5;
    calculate_dist item;
    for i=0 to 3 do
        if (!(d_array.(i)) < !dis_now) then
            r_array.(i) := 100;
    done;
    set_bar_dir item;
    get_weight_random_dir (Random.int (!r0 + !r1 + !r2 + !r3))
;;
let lv0_ai item =
    r0 := 25;
    r1 := 25;
    r2 := 25;
    r3 := 25;
    set_bar_dir item;
    get_weight_random_dir (Random.int (!r0 + !r1 + !r2 + !r3))
;;
let lv_array = [|lv0_ai; lv1_ai; lv2_ai|];;

let set_item_next_dir item =
    item#setMoveCounter 13;
    item#setNextDir (lv_array.(item#getLevel) item);

;;

(*  set the pacman as a global variable*)
let set_pacman player =
   pacman#setSpeed player#getSpeed;
   pacman#getPoint#setX player#getPoint#getX;
   pacman#getPoint#setY player#getPoint#getY;
   pacman#setColor player#getColor;

;;


(*  generate gifts  *)
let gene_gift mainMap x y = 
        let gift = new item in
        gift#setType 2;
        (gift#getPoint)#setX ((x*100)+50);
        (gift#getPoint)#setY ((y*100)+50);
        gift#setColor (0.3, 0.3, 0.);
        gift#setRadius 0.1;
        mainMap#addGift gift
;;


let generate_g mainMap = 
    let rec draw_into_map b_list = 
        match b_list with
        []->()
        | hd::tl ->
            map_bar.(hd#getPoint#getY).(hd#getPoint#getX) <- 1;
            draw_into_map tl
    in draw_into_map mainMap#getBars;
    let x = ref 0 in
    let y = ref 0 in
    for i=1 to 20 do
        while map_bar.(!y).(!x) != 0 do
            x := 1 + (Random.int 13);
            y := 1 + (Random.int 13);
        done;
        gene_gift mainMap !x !y;
        x := 0;
        y := 0;
    done
;;


(* set the map as a global variable  *)
let set_map mainMap =
   gmap#setPlayer mainMap#getPlayer;
   gmap#assignGhosts mainMap#getGhosts;
   gmap#assignGifts mainMap#getGifts;
   gmap#assignBars mainMap#getBars;
   set_pacman mainMap#getPlayer;   
   generate_g gmap;
;;

(*  print message and exit *)
let game_over message = 
    print_string("Score: ");
    print_int(!total_score);
    print_endline("");
    print_endline(message);
    exit 0;
;;


(* control and draw pacman  *)
let show_pacman mainMap =
  
  set_map mainMap;  
  ignore (Glut.init Sys.argv);
  Glut.initDisplayMode ~double_buffer:true ();
  Glut.initWindowSize ~w:512 ~h:512;
  ignore (Glut.createWindow ~title:"OpenGL Demo");
  GlClear.color (0.0, 0.0, 0.0);
  GlDraw.shade_model `smooth;
  let render () =
    GlMat.mode `projection;
    GlMat.load_identity ();
    GluMat.ortho2d ~x:(0., map_width) ~y:(0., map_height);
    GlMat.mode `modelview;
    GlMat.load_identity ();
    GlClear.clear [ `color ];
   

    let change_back p =
        p#setColor (1., 1., 0.);
        p#setSpeed 5;
        p#setStatus "normal";
    in let deal_status p =
        p#setTime (p#getTime - 1);
        if p#getTime <= 0 then
            change_back p;
    in let check_status p =
        if not (p#getStatus = "normal") then
            deal_status p;
    in check_status pacman;
    move_item pacman;

    let g4 g p =
        p#setStatus  "normal";
	total_score := !total_score + 100;
    in let g3 g p =
        p#setStatus  "killer";
        p#setTime  g#getDuration;
        p#setColor g#getColor;
    in let g1 g p =
        p#setSpeed  10;
        p#setStatus  "fast";
        p#setTime  g#getDuration;
        p#setColor g#getColor;
    in let g2 g p =
        p#setSpeed  1;
        p#setStatus  "slow";
        p#setTime  g#getDuration;
        p#setColor g#getColor;
    in let deal_gift g p =
        total_score := (!total_score + g#getScore);
        print_string("Score: ");
        print_int(!total_score);
        print_endline("");  
        if g#getLevel = 1 then
            g1 g p
        else if g#getLevel = 2 then
            g2 g p
        else if g#getLevel = 3 then
            g3 g p
        else if g#getLevel = 4 then
            g4 g p;
        g#setLevel (- 1);
        if(List.length gmap#getGifts) = 1 then
            game_over("You Win!!!!");
    in let check_gift g p = 
        if (abs (p#getPoint#getX - g#getPoint#getX) + 
            abs (p#getPoint#getY - g#getPoint#getY) )
            < (truncate((p#getRadius +. g#getRadius) *. 100.)) 
            then 
                deal_gift g p
        else
            draw_item g;
    in let rec check_gifts glist player = 
        match glist with
        []->[]
        | g1::tl -> 
            check_gift g1 player;
            if ((g1#getLevel) != -1) then
                g1::(check_gifts tl player)
            else
                check_gifts tl player
    in 
    gmap#assignGifts (check_gifts gmap#getGifts pacman);


    draw_item pacman;


   let move_ghost ghost = 
        if (check_item_change_dir ghost) then
            set_item_next_dir ghost;
        move_item ghost;
        ghost#setMoveCounter (ghost#getMoveCounter -1);
    in let rec move_ghosts mlist = 
        match mlist with
        []->()
        | m1::tl -> 
            move_ghost m1;      
            draw_item m1;
            move_ghosts tl;
    in move_ghosts gmap#getGhosts;

    let kill_ghost m =
        m#setLevel (- 1);
        total_score := !total_score + (10 * m#getLevel);
    in let deal_ghost m p =
        if p#getStatus = "killer" then
            kill_ghost m
        else
            game_over("Game Over -- You Lose!!! -- You are killed by a ghost");
    in let check_ghost m p = 
        if (abs (p#getPoint#getX - m#getPoint#getX) + 
            abs (p#getPoint#getY - m#getPoint#getY) )
            < (truncate((p#getRadius +. m#getRadius) *. 100.)) 
            then 
                deal_ghost m p;
    in let rec check_ghosts mlist player = 
        match mlist with
        []->[]
        | m1::tl -> 
            check_ghost m1 player;
            if ((m1#getLevel) != -1) then
                m1::(check_ghosts tl player)
            else
                check_ghosts tl player
    in 
    gmap#assignGhosts (check_ghosts gmap#getGhosts pacman);

    GlDraw.color colorb;

    let draw_box x y width = 
        GlDraw.begins `line_loop;
        List.iter GlDraw.vertex2 [x *. width, y *. width; 
                                  (x +. width ) *. width, y *. width; 
                                  (x +. width ) *. width, (y +.  width ) *. width; 
                                  x *. width, (y +.  width ) *. width];
        GlDraw.ends ();
    in
    let rec print_map_raw r x y = 
        if float(x) < map_width then
            if r.(x) = 1 then
                draw_box (float(x)) (float(y)) width;
        if float(x) < map_width then
            print_map_raw r (x+1) y;
    in let rec print_map_bar m y = 
        if float(y) < map_height then
            print_map_raw m.(y) 0 y;
        if float(y) < map_height then
            print_map_bar m (y+1);
    in print_map_bar map_bar 0;


    Gl.flush ();
    Glut.swapBuffers () in
  Glut.displayFunc ~cb:render;
  Glut.idleFunc ~cb:(Some Glut.postRedisplay);
  Glut.keyboardFunc ~cb:(keyboard);
  Glut.specialFunc ~cb:(special_key);
  Glut.mainLoop ()
;;

